summaryrefslogtreecommitdiffstats
path: root/target/linux/lantiq/base-files/etc
diff options
context:
space:
mode:
authorJohn Crispin <john@openwrt.org>2015-07-07 13:44:53 +0000
committerJohn Crispin <john@openwrt.org>2015-07-07 13:44:53 +0000
commit6bdd209f152d2c98fefabcc486dc063420cda6a9 (patch)
treeba01442cbdf1ea40480e8064dd9b974a1418bc9d /target/linux/lantiq/base-files/etc
parent2748df1c984e1ec105d95d42c87d67d637decdee (diff)
downloadmaster-31e0f0ae-6bdd209f152d2c98fefabcc486dc063420cda6a9.tar.gz
master-31e0f0ae-6bdd209f152d2c98fefabcc486dc063420cda6a9.tar.bz2
master-31e0f0ae-6bdd209f152d2c98fefabcc486dc063420cda6a9.zip
lantiq: Add support for the BT Home Hub 5A
u-boot support depends on the next "upstream" version ([0]) from Daniel Schwierzeck. Since the installation process is quite complicated a "how to" was added to the wiki: [1] [0] https://github.com/danielschwierzeck/u-boot-lantiq/tree/openwrt/v2014.01-next [1] http://wiki.openwrt.org/toh/bt/homehub_v5a V2: Use the correct PCI interrupt (fixes 2.4GHz wifi) Signed-off-by: Martin Blumenstingl <martin.blumenstingl@googlemail.com> SVN-Revision: 46223
Diffstat (limited to 'target/linux/lantiq/base-files/etc')
-rw-r--r--target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata51
-rw-r--r--target/linux/lantiq/base-files/etc/uci-defaults/01_leds2
-rw-r--r--target/linux/lantiq/base-files/etc/uci-defaults/02_network8
3 files changed, 60 insertions, 1 deletions
diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
new file mode 100644
index 0000000000..0d8084fa10
--- /dev/null
+++ b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
@@ -0,0 +1,51 @@
+#!/bin/sh
+# Based on ar71xx 11-ath10k-caldata and 10-rt2x00-eeprom
+
+ath10k_caldata_die() {
+ echo "ath10k caldata: " "$*"
+ exit 1
+}
+
+ath10k_caldata_extract() {
+ local part=$1
+ local offset=$2
+ local mtd
+
+ . /lib/functions.sh
+
+ mtd=$(find_mtd_part $part)
+ [ -n "$mtd" ] || \
+ ath10k_caldata_die "no mtd device found for partition $part"
+
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=2116 || \
+ ath10k_caldata_die "failed to extract from $mtd"
+}
+
+ath10k_caldata_set_macaddr() {
+ local macaddr=$1
+
+ macaddr_2bin $macaddr | dd of=/lib/firmware/$FIRMWARE \
+ conv=notrunc bs=1 seek=6 count=6
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+. /lib/functions.sh
+. /lib/functions/system.sh
+. /lib/functions/lantiq.sh
+
+case "$FIRMWARE" in
+"ath10k/cal-pci-0000:02:00.0.bin")
+ local board=$(lantiq_board_name)
+ case $board in
+ BTHOMEHUBV5A)
+ local lan_mac=$(mtd_get_mac_binary caldata 4364)
+ local wifi_mac=$(macaddr_add "$lan_mac" 3)
+ ath10k_caldata_extract "caldata" 20480
+ ath10k_caldata_set_macaddr $wifi_mac
+ ;;
+ *)
+ ath10k_caldata_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac
diff --git a/target/linux/lantiq/base-files/etc/uci-defaults/01_leds b/target/linux/lantiq/base-files/etc/uci-defaults/01_leds
index 8041ac941f..3e05ebaa87 100644
--- a/target/linux/lantiq/base-files/etc/uci-defaults/01_leds
+++ b/target/linux/lantiq/base-files/etc/uci-defaults/01_leds
@@ -25,7 +25,7 @@ BTHOMEHUBV2B)
ucidef_set_led_netdev "internet" "internet" "soc:blue:broadband" "pppoa-wan"
ucidef_set_led_usbdev "usb" "usb" "soc:blue:phone" "1-1"
;;
-BTHOMEHUBV3A)
+BTHOMEHUBV3A|BTHOMEHUBV5A)
ucidef_set_led_default "power" "power" "soc:blue:power" "1"
ucidef_set_led_wlan "wifi" "wifi" "soc:blue:wireless" "phy0tpt"
ucidef_set_led_netdev "internet" "internet" "soc:blue:broadband" "pppoa-wan"
diff --git a/target/linux/lantiq/base-files/etc/uci-defaults/02_network b/target/linux/lantiq/base-files/etc/uci-defaults/02_network
index afb8714fe8..6f9d9c022d 100644
--- a/target/linux/lantiq/base-files/etc/uci-defaults/02_network
+++ b/target/linux/lantiq/base-files/etc/uci-defaults/02_network
@@ -169,6 +169,14 @@ BTHOMEHUBV2B|BTHOMEHUBV3A)
wan_mac=$(macaddr_add "$lan_mac" 1)
;;
+BTHOMEHUBV5A)
+ lan_mac=$(mtd_get_mac_binary caldata 4364)
+ wan_mac=$(macaddr_add "$lan_mac" 1)
+ ucidef_set_interface_lan 'eth0.1'
+ ucidef_add_switch "switch0" "1" "1"
+ ucidef_add_switch_vlan "switch0" "1" "0 1 2 4 6t"
+ ;;
+
VGV7519)
lan_mac=$(mtd_get_mac_binary board_config 22)
wan_mac=$(macaddr_add "$lan_mac" 1)